#include <stdio.h>
#include "nivel.h"
#include "jugador.h"
#include "enemigo.h"
#include "objeto.h"
#include "item.h"
#include <SDL/SDL_image.h>
#define TEMPO 30
using namespace std;

Nivel::Nivel(const Jugador& j,const Enemigo& e):munyeco(j),coche(e){}

int Nivel::Jugar(SDL_Surface *pantalla){
SDL_Event evento;
Uint32 negro = SDL_MapRGB(pantalla->format, 0, 0, 0);
SDL_Surface *fondo=IMG_Load("img/escanerio_n1.png");

if ( fondo == NULL ) {
        fprintf(stderr, "No pude cargar %s: %s\n", "escenari_n1.png", SDL_GetError());
        return 0;
}
SDL_Rect dest;
    dest.x = 0;
    dest.y = 0;
    dest.w = fondo->w;
    dest.h = fondo->h;
    
Objeto o(200,200);
Item i(500,400);
Uint32 t0 = SDL_GetTicks();
Uint32 t1;
t1 = SDL_GetTicks();

for( ; ; ){
   t1 = SDL_GetTicks(); 
   if((t1 - t0) > TEMPO) {
	SDL_BlitSurface(fondo, NULL, pantalla, &dest);
	if(coche.movimiento(munyeco))
		return 0;
	coche.mostrar(pantalla);
	o.mostrar(pantalla);
	i.mostrar(pantalla);
	munyeco.mostrar(pantalla);   
	SDL_Flip(pantalla);
	t0 = SDL_GetTicks();
	}

	if(SDL_PollEvent(&evento))
	    if(evento.type == SDL_KEYDOWN) {
	
		if(evento.key.keysym.sym == SDLK_UP){
			while(evento.type!=SDL_KEYUP){
				munyeco.mover(0,o);
				if(coche.movimiento(munyeco) || i.colision(munyeco))
					return 0;				
				SDL_BlitSurface(fondo, NULL, pantalla, &dest);
				coche.mostrar(pantalla);
				i.mostrar(pantalla);
				o.mostrar(pantalla);
				munyeco.mostrar(pantalla);   
				SDL_Flip(pantalla);
				SDL_PollEvent(&evento);
				t1 = SDL_GetTicks(); 
   				if((t1 - t0) > TEMPO)
					t0 = SDL_GetTicks();
			}
		}

		if(evento.key.keysym.sym == SDLK_DOWN){
			while(evento.type!=SDL_KEYUP){
				munyeco.mover(1,o);
				if(coche.movimiento(munyeco) || i.colision(munyeco))
					return 0;				
				SDL_BlitSurface(fondo, NULL, pantalla, &dest);
				coche.mostrar(pantalla);
				o.mostrar(pantalla);	
				i.mostrar(pantalla);			
				munyeco.mostrar(pantalla);   
				SDL_Flip(pantalla);
				SDL_PollEvent(&evento);
				t1 = SDL_GetTicks(); 
   				if((t1 - t0) > TEMPO)
					t0 = SDL_GetTicks();
			}
		}
		if(evento.key.keysym.sym == SDLK_LEFT){

			while(evento.type!=SDL_KEYUP){
				munyeco.mover(2,o);
				if(coche.movimiento(munyeco) || i.colision(munyeco))
					return 0;				
				SDL_BlitSurface(fondo, NULL, pantalla, &dest);
				coche.mostrar(pantalla);
				o.mostrar(pantalla);
				i.mostrar(pantalla);
				munyeco.mostrar(pantalla);   
				SDL_Flip(pantalla);
				SDL_PollEvent(&evento);
				t1 = SDL_GetTicks(); 
   				if((t1 - t0) > TEMPO)
					t0 = SDL_GetTicks();
			}
		}
		if(evento.key.keysym.sym == SDLK_RIGHT){

			while(evento.type!=SDL_KEYUP){
				munyeco.mover(3,o);
				if(coche.movimiento(munyeco) || i.colision(munyeco))
					return 0;				
				SDL_BlitSurface(fondo, NULL, pantalla, &dest);
				coche.mostrar(pantalla);
				o.mostrar(pantalla);
				i.mostrar(pantalla);	
				munyeco.mostrar(pantalla);   
				SDL_Flip(pantalla);
				SDL_PollEvent(&evento);
				t1 = SDL_GetTicks(); 
   				if((t1 - t0) > TEMPO)
					t0 = SDL_GetTicks();
			}
		}
		if(evento.key.keysym.sym == SDLK_ESCAPE)
		    
		    return 0;

	}

}
SDL_FreeSurface(fondo);
}
